#ifndef	_ADXT_H_INCLUDED
#define	_ADXT_H_INCLUDED
/****************************************************************************/
/*																			*/
/*			$title$ `cwf[^Đ Cu								*/
/*					ADXT (ADX TALK) Library									*/
/*																			*/
/*				1997.2.25		written M.Oshimi							*/
/*																			*/
/****************************************************************************/

#define	ADXT_VER	"5.42"

/*	gX|[Y@\邩ۂ	*/
/*
#define		TRNSPS
*/

/*	Xg[WCg	*/
#ifndef SJ_DEFINED
#define SJ_DEFINED
typedef void *SJ;
#endif


/*	Xg[Rg[	*/
#ifndef ADXSTM_DEFINED
#define ADXSTM_DEFINED
typedef	void	*ADXSTM;
#endif
/*	Xg[WCgfR[_	*/
#ifndef ADXSJD_DEFINED
#define ADXSJD_DEFINED
typedef void	*ADXSJD;
#endif
/*	I[fBI_	*/
#ifndef ADXRNA_DEFINED
#define ADXRNA_DEFINED
typedef void	*ADXRNA;
#endif

#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif

/*	ő哯	*/
#define	ADXT_MAX_OBJ		(8)

/*	őf[^TCY	*/	
#define	ADXT_MAX_DATASIZE	(0x40000000)

/*	̓obt@̃GLXg̈̑傫	*/
#define ADXT_IBUF_XLEN (36)

/*	ADX Talk ̏o̓obt@̑傫@iTvPʁj	*/
#define	ADXT_OBUF_SIZE	(0x2000)
#define	ADXT_OBUF_DIST	(0x2020)

#define	ADXT_MAX_SFREQ	(44100)

/*	ADX Talk̍Đ	(ADXT_CALC_WORK}NŎgp)	*/
#define ADXT_PLY_MEM	(0)			/*	ɂĐ			*/
#define ADXT_PLY_STM	(1)			/*	CD̃Xg[Đ		*/

/*
#define ADXT_CALC_IBUFSIZE0(nch, sfreq)	\
	((long)((double)25000.0*(double)(sfreq)/(double)44100)*(nch))
*/
/*	1998.9.9
#define ADXT_CALC_IBUFSIZE0(nch, sfreq)	(25000*(nch)*44/((sfreq)/1000))
*/
#define ADXT_CALC_IBUFSIZE0(nch, sfreq)	(25000*(nch)*((sfreq)/1000)/44)

#define ADXT_CALC_IBUFSIZE(nch, nstm, sfreq)	\
	((ADXT_CALC_IBUFSIZE0(nch, sfreq)*((nstm)+1)+2048)/2048*2048+ADXT_IBUF_XLEN)
#define ADXT_CALC_OBUFSIZE(nch)	\
	( ADXT_OBUF_DIST*(nch)*sizeof(short))
#define ADXT_CALC_WORK(nch, stmflg, nstm, sfreq)	\
	(ADXT_CALC_IBUFSIZE(nch, nstm, sfreq)*(stmflg) + ADXT_CALC_OBUFSIZE(nch) + 32)

/*	bcobt@ւ̓ǂݍݗ	*/
#define ADXT_MAX_CDBSCT		(75)
#define ADXT_MIN_CDBSCT		(65)
#define ADXT_PREP_RDSCT		(25)

/* $define$ ADX Talk̓(ADXT_STAT_`) */
#define	ADXT_STAT_STOP		(0)		/* ~ 					*/
#define ADXT_STAT_DECINFO	(1)		/* `cw ̃wb_擾*/
#define ADXT_STAT_PREP		(2)		/* Đ 				*/
#define ADXT_STAT_PLAYING	(3)		/* fR[hĐ 		*/
#define ADXT_STAT_DECEND	(4)		/* fR[hI 			*/
#define ADXT_STAT_PLAYEND	(5)		/* ĐI 				*/

/* $define$ ADX Talk̃G[R[h@(ADXT_ERR_`) */
#define	ADXT_ERR_OK			(0)		/*  					*/
#define ADXT_ERR_SHRTBUF	(-1)	/* ̓obt@GveB	*/
#define ADXT_ERR_SNDBLK		(-2)	/* TEhubNG[	*/

/*	$define$ tB^[h	(ADXT_FLTMODE_`)*/
#define	ADXT_FLTMODE_CPU	(0)		/*	botɂWJ[h		*/
#define	ADXT_FLTMODE_SCSP	(1)		/*	AICA-DSPɂWJ[h	*/

/*	$define$ Đ[h	(ADXT_PMODE_`)*/
#define	ADXT_PMODE_FNAME	(0)		/*	t@C܂ FID ɂw		*/
#define	ADXT_PMODE_AFS		(1)		/*	AFS ɂw						*/
#define	ADXT_PMODE_MEM		(2)		/*	Đ							*/
#define	ADXT_PMODE_SJ		(3)		/*	Xg[WCgĐ			*/

/*	$define$ G[Jo[[h	(ADXT_RMODE_`)*/
#define	ADXT_RMODE_NOACT	(0)		/*	Jo[Ȃ					*/
#define	ADXT_RMODE_STOP		(1)		/*	~							*/
#define	ADXT_RMODE_REPLAY	(2)		/*	ăvC						*/

/*	p|bg̐ݒl		*/
#define	ADXT_PAN_LEFT		(-15)
#define	ADXT_PAN_CENTER		(0)
#define	ADXT_PAN_RIGHT		(15)
#define	ADXT_PAN_AUTO		(-128)	/*	MONO/STE ɂĎIɐ؂ւ*/

/*	XeIĐ̃`lԍ	*/
#define	ADXT_CH_L			(0)
#define	ADXT_CH_R			(1)

/*	őĐ`l	*/
#define	ADXT_MAX_NCH		(2)

/*	T[o֐̌Ăяopx̋Kl@60i/bj	*/
#define ADXT_DEF_SVRFREQ	(60)

#define	ADXT_DEF_OUTVOL		(0)

/*	̓obt@̉l (G[pAPʃoCgj	*/
#define	ADXT_MIN_BUFDATA	(64)

/*	G[҂ԁ@iP:b)	*/
#define	ADXT_EWAIT_PLY		(5)
#define	ADXT_EWAIT_NOTPLY	(5)

/*	CfbNX̍ő吔	*/
#define	ADXT_MAX_IDX	(0xFFFF)

/*	ADX Talk IuWFNg\	*/
typedef	struct _adx_talk {
	char	used;						/*	gpۂ					*/
	char	stat;						/*							*/
	char	pmode;						/*	Đ[h						*/
	char	maxnch;						/*	őĐ`l			*/
	ADXSJD	sjd;						/*	ADXXg[WCgfR[_	*/
	ADXSTM	stm;						/*	̓Xg[Rg[		*/
	ADXRNA	rna;						/*	I[fBI_				*/
	SJ		sjf;						/*	t@C̓Xg[WCg*/
	SJ		sji;						/*	̓Xg[WCg		*/
	SJ		sjo[ADXT_MAX_NCH];			/*	o̓Xg[WCg		*/
	char	*ibuf;						/*	̓obt@					*/
	long	ibuflen;					/*	̓obt@TCYioCgP)	*/
	long	ibufxlen;					/*	̓obt@GNXgTCY	*/
	short	*obuf;						/*	o̓obt@					*/
	long	obufsize;					/*	o̓obt@TCYiTvj	*/
	long	obufdist;					/*	o̓obt@ԊuiTvj	*/
	long	svrfreq;					/*	T[o֐Ăяopx			*/
	short	maxsct;						/*	̓obt@̍ōZN^	*/
	short	minsct;						/*	̓obt@̍ŒZN^	*/
	short	outvol;						/*	o̓{[					*/
	short	outpan[ADXT_MAX_NCH];		/*	o̓p|bg̐ݒl			*/
	long	maxdecsmpl;					/*	őfR[hTv			*/
	long	lpcnt;						/*	[vJE^					*/
	long	lp_skiplen;					/*	[vXLbvoCg			*/
	long	trp;						/*	gX|[Y (Zg)		*/
	long	wpos;						/*	fBȀ݈ʒu		*/
	long	mofst;						/*	fBÃItZbg			*/
	short	ercode;						/*	G[R[h					*/
	long	edecpos;					/*	G[opfR[hʒu		*/
	short	edeccnt;					/*	fR[hʒuJE^			*/
	short	eshrtcnt;					/*	ޯ̧è			*/
	char	lpflg;						/*	[v邩ۂ				*/
	char	autorcvr;					/*	IɃG[A邩ۂ	*/
	char	fltmode;					/*	tB^[h					*/
	char	execflag;					/*	T[os邩ۂ			*/
	char	pstwait_flag;				/*	o͊Jn҂tO			*/
	char	pstready_flag;				/*	o͏tO			*/
} ADX_TALK;
typedef	ADX_TALK	*ADXT;

/*	CfbNXf[^	*/
typedef struct _adxt_idx {
	unsigned short nidx;
	unsigned short top;
} ADXT_IDX;

/* $func$ ADX Talk ̏
 * [@] void ADXT_Init(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk B
 *			ϐ̈̏sB
 */
void ADXT_Init(void);

/* $func$ ADX Talk ̍ď
 * [@] void ADXT_Reset(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk ďB
 *			ϐ̈̏sB
 */
void ADXT_Reset(void);

/* $func$ ADX Talk̏I
 * [@] void ADXT_Finish(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk ̏IB
 */
void ADXT_Finish(void);

/*	$func$ ADXTnh ̐
 * [@] ADXT ADXT_Create(long maxnch, void *work, long worksize);
 * [@] maxnch	: őĐ`lim݂̂PFXeIQj
 *			work	: [N̈
 *			worksize: ĐtOiĐ̂:1)
 * [o@] Ȃ
 * [֐l] ADXTnh
 * [@@\] ADXTnh𐶐B
 *			work̈̃TCÝAADXT_CALC_WORK_SIZE}Nɂċ߂B
 *			work̈́A32byteoE_łȂ΂ȂȂB
 *			Đ݂̂sꍇ́AmemflagPɂB
 */
ADXT ADXT_Create(long maxnch, void *work, long worksize);

/* $func$ ADXTnh ̏
 * [@] void ADXT_Destroy(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] w肳ꂽ ADXTnhB
 */
void ADXT_Destroy(ADXT adxt);

/* $func$ FID wɂĐ̊Jn
 * [@] void ADXT_StartAfs(ADXT adxt, long patid, long fid);
 * [@] adxt	: ADXTnh
 *			patid	: p[eBVʎq
 *			fid		: t@Cʎq
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] p[eBVʎqƃt@CʎqŎw肳ꂽ`cwt@C
 *			ĐJnB
 */
void ADXT_StartAfs(ADXT adxt, long patid, long fid);

/* $func$ t@CwɂĐ̊Jn
 * [@] void ADXT_StartFname(ADXT adxt, char *fname);
 * [@] adxt	: ADXTnh
 *			fnmae	: t@C
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] fname Ŏw肳ꂽ`cwt@C̍ĐJnB
 */
void ADXT_StartFname(ADXT adxt, char *fname);

/* $func$ Xg[WCgɂĐ̊Jn
 * [@] void ADXT_StartMem(ADXT adxt, SJ sj);
 * [@] adxt	: ADXTnh
 *			sj		: Xg[WCg
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] Xg[WCg瓾f[^ĐB
 */
void ADXT_StartSj(ADXT adxt, SJ sj);

/* $func$ wɂĐ̊Jn
 * [@] void ADXT_StartMem(ADXT adxt, void *adxdat, long no);
 * [@] adxt	: ADXTnh
 *			adxdat	: `cwf[^
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] adxdatŎw肳ꂽ`cwf[^ĐB
 */
void ADXT_StartMem(ADXT adxt, void *adxdat);

/* $func$ wɂĐ̊Jn
 * [@] void ADXT_StartMemIdx(ADXT adxt, void *acx, long no);
 * [@] adxt	: ADXTnh
 *			acx		: `cwʉf[^
 *			no		: ʉԍ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] acx Ŏw肳ꂽ`cwʉf[^noԖڂ̃f[^ĐB
 */
void ADXT_StartMemIdx(ADXT adxt, void *acx, long no);

/* $func$ Đ̒~
 * [@] void ADXT_Stop(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] `cw̍Đ~B
 */
void ADXT_Stop(ADXT adxt);

/* $func$ Ԃ̎擾
 * [@] long ADXT_GetStat( ADXT adxt );
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] ݂ ADXTnh̏Ԃ\萔
 * 				ADXT_STAT_STOP	 :	~
 *				ADXT_STAT_DECINFO:	`cw ̃wb_擾
 *				ADXT_STAT_PREP	 :	Đ
 *				ADXT_STAT_PLAYING:	fR[hĐ
 *				ADXT_STAT_DECEND :	fR[hI
 *				ADXT_STAT_PLAYEND:	ĐI
 * [@@\] ݂ADXTnh̏Ԃ擾B
 */
long ADXT_GetStat(ADXT adxt);

/* $func$ TvPʂł̍Đ̎擾
 * [@] void ADXT_GetTime( ADXT adxt, long *ncount, long *tscale );
 * [@] adxt	: ADXTnh
 * [o@] ncount	: ĐTv
 *			tscale	: TvOg [ Hz ]
 * [֐l] Ȃ
 * [@@\] TvPʂōĐ擾B
 */
void ADXT_GetTime(ADXT adxt, long *ncount, long *tscale);

/* $func$ Ԃł̍Đ̎擾
 * [@] long ADXT_GetTimeReal(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Đ [ 1/100sec ]
 * [@@\] ԂōĐ擾B
 */
long ADXT_GetTimeReal(ADXT adxt);

/* $func$ f[^̑Tv̎擾
 * [@] long ADXT_GetNumSmpl( ADXT adxt );
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̑Tv
 * [@@\] Đ `cw f[^̑Tv擾B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 */
long ADXT_GetNumSmpl(ADXT adxt);

/* $func$ f[^̃TvOg̎擾
 * [@] long ADXT_GetSfreq(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̃TvOg
 * [@@\] Đ TvOg߂B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 */
long ADXT_GetSfreq(ADXT adxt);

/*	$func$ p|bg̐ݒ
 * [@] void ADXT_SetOutPan(ADXT adxt, long ch, long pan);
 * [@] adxt	: ADXTnh
 *			ch		: `lԍ (0, 1)
 *						ADXT_CH_L=0, ADXT_CH_R=1
 *			pan		: pݒl (-15`+15, -128)
 *						ADXT_PAN_LEFT=-15, ADXT_PAN_CENTER=0
 *						ADXT_PAN_RIGHT=15, ADXT_PAN_AUTO=-128
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] o̓p|bgݒ肷B̍ĐJnOɐݒ肷B
 *			AUTO ̏ꍇ́AADX f[^mXeIɂĎI
 *			pݒ肳B
 */
void ADXT_SetOutPan(ADXT adxt, long ch, long pan);

/*	$func$ p|bg̎擾
 * [@] void ADXT_GetOutPan(ADXT adxt, long ch);
 * [@] adxt	: ADXTnh
 *			ch		: `lԍ (0, 1)
 *						ADXT_CH_L=0, ADXT_CH_R=1
 * [o@] Ȃ
 * [֐l] p|bg̐ݒl
 * [@@\] o̓p|bg擾B
 */
long ADXT_GetOutPan(ADXT adxt, long ch);

/*	$func$ o̓{[̐ݒ
 * [@] void ADXT_SetOutVol(ADXT adxt, long vol);
 * [@] adxt	: ADXTnh
 *			vol		: x@(0:-0dB, -960=-96dB)
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] o̓{[ݒ肷B
 *			vol̐ݒl	0    :  -0dB  Ȃ
 *						-30  :  -3dB  70%
 *						-60  :  -6dB  50%
 *						-960 : -96dB  ő̌
 */
void ADXT_SetOutVol(ADXT adxt, long vol);

/*	$func$ o̓{[̎擾
 * [@] void ADXT_GetOutVol(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] o̓{[̐ݒl@(0:-0dB ` -960:-96dB)
 * [@@\] o̓{[擾B
 */
long ADXT_GetOutVol(ADXT adxt);

/*	$func$ T[o֐̌Ăяopx̐ݒ	(Pb̌Ăяo)
 * [@] void ADXT_SetSvrFreq(ADXT adxt, long freq);
 * [@] adxt	: ADXTnh
 *			freq	: T[o֐̌Ăяopx (Pb̌Ăяo)
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] T[o֐(ADXT_ExecServer֐)̌Ăяopx̐ݒ肷B
 *			ftHgł́A60ݒ肳ĂB
 *			ʏAݒ肷Kv͂ȂB
 */
void ADXT_SetSvrFreq(ADXT adxt, long freq);

/*	$func$ ēǂݍ݊JnZN^̐ݒ
 * [@] void ADXT_SetReloadSct(ADXT adxt, long minsct);
 * [@] adxt	: ADXTnh
 *			minsct	: ēǂݍ݊JnZN^
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ̓obt@ւ̍ēǂݍ݊JnZN^ݒ肷B
 *			bcobt@̗ʂ min ZN^菭ȂȂƂbc
 *			f[^ǂݍށB
 */
void ADXT_SetReloadSct(ADXT adxt, long minsct);

/*	$func$ ̓obt@̃ZN^̎擾
 * [@] long ADXT_GetNumSctIbuf(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] ZN^
 * [@@\] ̓obt@ɓǂݍ܂ĂZN^擾B
 */
long ADXT_GetNumSctIbuf(ADXT adxt);

/*	$func$ ̓obt@ɏ\ȃf[^邩ۂ̌
 * [@] long ADXT_IsIbufSafety(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] TRUE(1):\ȃf[^AFALSE(0):f[^s
 * [@@\] ̓obt@ɏ\ȃf[^邩ۂB
 *			ADXT_SetReloadSct֐ɂĎw肳ꂽēǂݍ݊JnZN^ȏ
 *			f[^bcobt@ɑ݂ꍇATRUEԂB
 */
long ADXT_IsIbufSafety(ADXT adxt);

/*	$func$ G[Jo[[h̎w
 * [@] void ADXT_SetAutoRcvr(ADXT adxt, long rmode);
 * [@] adxt	: ADXTnh
 *			rmode	: G[Jo[̕@
 *					  ADXT_RMODE_NOACT, ADXT_RMODE_STOP, ADXT_RMODE_REPLAY
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[Jo[̕@ݒ肷B
 *			ADXT_RMODE_NOACT : G[Jo[Ȃ
 *			ADXT_RMODE_STOP  : Iɒ~AԂADXT_STAT_STOPɂȂB
 *			ADXT_RMODE_REPLAY: CD̃f[^̋r؂ꂽƂɁAI
 *							   t@C̐擪ĐB
 *							   ̑̏ꍇ́AIɒ~B
 */
void ADXT_SetAutoRcvr(ADXT adxt, long rmode);

/*	$func$ ĐIۂ̌
 * [@] long ADXT_IsCompleted(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] 1:ĐIA0:Đ
 * [@@\] adxtĐIۂ𒲂ׂB
 */
long ADXT_IsCompleted(ADXT adxt);

/*	$func$ enh̃T[o֐@iԂ̍XV)
 * [@] long ADXT_ExecHndl(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] enh̓ԂXVB
 *			ADXT_ExecServerĂяoB
 */
void ADXT_ExecHndl(ADXT adxt);

/*	$func$ T[o֐@iԂ̍XV)
 * [@] long ADXT_ExecServer(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] Cu̓ԂXVB
 *			V-Sync ɌĂяoȂ΂ȂȂB
 */
void ADXT_ExecServer(void);

/*	$func$ G[R[h̎擾
 * [@] long ADXT_GetErrCode(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[R[h擾B
 */
long ADXT_GetErrCode(ADXT adxt);

/*	$func$ G[R[h̃NA
 * [@] void ADXT_ClearErrCode(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[R[hNAB
 */
void ADXT_ClearErrCode(ADXT adxt);

/*	$func$ [v񐔂̎擾
 * [@] long ADXT_GetLpCnt(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] [v
 * [@@\] [v񐔂擾B
 */
long ADXT_GetLpCnt(ADXT adxt);

/*	$func$ [vtO̐ݒ
 * [@] void ADXT_SetLpFlg(ADXT adxt, long flg);
 * [@] adxt	: ADXTnh
 *			flg		: 1=[vA0=[vȂ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] [v邩ۂݒ肷B
 */
void ADXT_SetLpFlg(ADXT adxt, long flg);

/*	$func$ ͂ri̎擾
 * [@] SJ ADXT_GetInputSj(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Xg[WCgnh
 * [@@\] ͗pXg[WCg擾B
 */
SJ ADXT_GetInputSj(ADXT adxt);

/*	$func$ o͊Jn҂̐ݒ
 * [@] void ADXT_SetWaitPlayStart(ADXT adxt, long flg);
 * [@] adxt	: ADXTnh
 *			flg		: 1=EFCgA0=o͂𑦍ɊJn
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ̏o͂̊Jn҂ݒ肷B
 */
void ADXT_SetWaitPlayStart(ADXT adxt, long flg);

/*	$func$ o͊Jnۂ̔
 * [@] void ADXT_IsReadyPlayStart(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] 
 * [@@\] [v邩ۂݒ肷B
 */
long ADXT_IsReadyPlayStart(ADXT adxt);

/*	$func$ GtFN^̐ݒ
 * [@] void ADXT_SetFx(ADXT adxt, long fxch, long fxlvl);
 * [@] adxt	: ADXTnh
 *			fxch	: GtFN^̓̓`lԍ (0`15)
 *			fxlvl	: GtFN^̓̓x@(0`15)
 * [o@] Ȃ
 * [֐l] 
 * [@@\] GtFN^ւ̏o͂ݒ肷B
 */
void ADXT_SetFx(ADXT adxt, long fxch, long fxlvl);

/*	$func$ GtFN^ݒl̎擾
 * [@] void ADXT_GetFx(ADXT adxt, long *fxch, long *fxlvl);
 * [@] adxt	: ADXTnh
 * [o@] fxch	: GtFN^ւ̓̓`lԍ (0`15)
 *			fxlvl	: GtFN^ւ̓̓x@(0`15)
 * [֐l] 
 * [@@\] GtFN^̐ݒl擾B
 */
void ADXT_GetFx(ADXT adxt, long *fxch, long *fxlvl);

/*	$func$ tB^̐ݒ
 * [@] void ADXT_SetFilter(ADXT adxt, long coff, long q);
 * [@] adxt	: ADXTnh
 *			coff	: JbgItg
 *			q		: sx
 * [o@] Ȃ
 * [֐l] 
 * [@@\] tB^ւ̏o͂ݒ肷B
 */
void ADXT_SetFilter(ADXT adxt, long coff, long q);

/*	$func$ tB^ݒl̎擾
 * [@] void ADXT_GetFilter(ADXT adxt, long *coff, long *q);
 * [@] adxt	: ADXTnh
 * [o@] coff	: JbgItg
 *			q		: sx
 * [֐l] 
 * [@@\] tB^ւ̏o͒l擾B
 */
void ADXT_GetFilter(ADXT adxt, long *coff, long *q);

/*	$func$ gX|[Y̐ݒ
 * [@] void ADXT_SetTranspose(ADXT adxt, long transps, long detune);
 * [@] adxt	: ADXTnh
 *			transps	: gX|[Y
 *			detune	: f`[
 * [o@] Ȃ
 * [֐l] 
 * [@@\] gX|[Yݒ肷B
 */
void ADXT_SetTranspose(ADXT adxt, long transps, long detune);

/*	$func$ gX|[Y̎擾
 * [@] void ADXT_GetTranspose(ADXT adxt, long *transps, long *detune);
 * [@] adxt	: ADXTnh
 * [o@] transps	: gX|[Y
 *			detune	: f`[
 * [֐l] 
 * [@@\] gX|[Yʂ擾B
 */
void ADXT_GetTranspose(ADXT adxt, long *transps, long *detune);

/*	$func$ G[֐̓o^
 * [@] void ADXT_EntryErrFunc(void (*func)(void *obj, char *msg),
 *																void *obj);
 * [@] func	: G[֐
 *			obj		: G[֐̑1
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[֐o^B
 */
void ADXT_EntryErrFunc(void (*func)(void *obj, char *msg), void *obj);

#endif
