/*
 *			ADXT TvvO No.1
 *				(bcXg[Đ)
 */

/***
*		`
***/

#include	<math.h>
#include	<string.h>

#include	"cri_adxf.h"
#include	"cri_adxt.h"

/*	Đő`l	*/
#define	MAX_CH			(2)
/*	ĐőCDXg[	*/
#define	MAX_CDSTM		(1)
/*	ōTvOg	*/
#define	MAX_SFREQ		(44100)

/***
*		TEh̏
***/

#include	"shinobi.h"
#include	"sg_sd.h"

/* TEhhCo̓]E */
Void	sound_init(Void *ptr)
{
	SDMEMBLK	memblk = NULL;

	/*	Initialize Sound library	 */
	sdLibInit(NULL, 0, 0);		/*	This api's argument is dummy now.  */

	/* 	Download and Initialize Sound driver.	 */
	/*	Create Memory block handle  */
	sdMemBlkCreate(&memblk);
	/*  Setting Memoby block handle  */
	sdMemBlkSetPrm(memblk, ptr, 0, SDD_MEMBLK_SYNC_FUNC, NULL);
	/*	Initialize Sound driver  */
	sdDrvInit(memblk);
	sdMemBlkDestroy(memblk);
}

/***
*			[eBeB֐
***/

/*	f[^̓ǂݍ	*/
void *load_file(char *fname, long *len)
{
	GDFS gdfs;
	long fsize, nsct;
	void *dat=NULL;

	if ( (gdfs=gdFsOpen(fname, NULL)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(3, 5), "can't open %s", fname);
			njWaitVSync();
		}
	}
	gdFsGetFileSize(gdfs, &fsize);
	nsct = (fsize+2047)/2048;
	if ( (dat=syMalloc(nsct*2048)) != NULL ) {
		gdFsRead(gdfs, nsct, dat);
	}
	gdFsClose(gdfs);
	if ( len != NULL )
		*len = fsize;

	return dat;
}

/*	Ԃ̕ϊ	*/
void sfcnt2time(long sf, long ncnt, long *hh, long *mm, long *ss, long *ff)
{
	register long nf = (long)((double)ncnt/(double)sf*100.0);

	*hh = nf/(60*60*100);
	*mm = nf/(60*100) - *hh*60;
	*ss = nf/100 - *hh*60*60 - *mm*60;
	*ff = nf%100;
}

/* GDt@CVXẽG[ɋN֐ */
void usr_gd_err_func(void *obj, Sint32 errcode)
{
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT) {
		/*	CuI					*/
		ADXT_Finish();
		/*	ECȕI				*/
		sbExitSystem();
		/*	VvvCփWv			*/
		syBtExit();
 	}
 	return;
}

/* [UVSYNC荞ݓo^֐ */
static void usr_vsync_func(void)
{
	Sint32 dstat;

    /* TEhCũT[o */
    sdSysServer();
	/* GDhCȕԃ`FbN */
	dstat = gdFsGetDrvStat();
	if (dstat == GDD_DRVSTAT_OPEN || dstat == GDD_DRVSTAT_BUSY) {
		gdFsReqDrvStat();
	}
	return;
}

/***
*			TvvO
***/

/*	Ԃ̕\	*/
void adxtst_disp_stat(ADXT adxt)
{
	char *ststr[6] =
		{"STOP   ", "DECINFO   ", "PREP   ", "PLAYING", "DECEND ", "PLAYEND"};
	long stat, sfreq, cnt, td;
	long hh, mm, ss, ff;
	extern long adxt_svrcnt;

	njPrint(NJM_LOCATION(3, 3), "ADX Sample Program No.1");
	njPrint(NJM_LOCATION(3, 4), "   ( CD Stream Play )");
	stat = ADXT_GetStat(adxt);
	njPrint(NJM_LOCATION(3, 6), "Stat = %s", ststr[stat]);
	ADXT_GetTime(adxt, &cnt, &sfreq);
	sfcnt2time(sfreq,  cnt, &hh, &mm, &ss, &ff);
	njPrint(NJM_LOCATION(3, 7), "Time = %2d:%2d:%2d.%2d", hh, mm, ss, ff);
	td = syTmrCountToMicro(adxt_svrcnt);
	njPrint(NJM_LOCATION(3, 9), "CPU Load = %4d (%2d%%)", td, td*100/16667);
}

/*	t@CĐp[N̈̑傫	*/
#define	WKSIZE		(ADXT_CALC_WORK(MAX_CH, 1, MAX_CDSTM, MAX_SFREQ))
/*	t@CĐp ADXT [N̈	*/
char work[WKSIZE];
ADXT adxt;


/*	ADX t@CĐTv	*/
void adxsmp(void)
{
	/*	ADXT nh̐	*/
	if ( (adxt=ADXT_Create(2, work, WKSIZE)) == NULL ) {
		for (;;) {
			njPrint(NJM_LOCATION(5, 5), "can't create ADXT\n");
			njWaitVSync();
		}
	}
	/*	G[΍̐ݒ (BGM̂ƂREPLAYAZtȂǂSTOP)	*/
	ADXT_SetAutoRcvr(adxt, ADXT_RMODE_REPLAY);
	/*	ĐJn	*/
	ADXT_StartFname(adxt, "SAMPLE.ADX");
	for (;;) {
		adxtst_disp_stat(adxt);
		/*	Ԃ̎擾	*/
		if ( ADXT_GetStat(adxt) == ADXT_STAT_PLAYEND )
			break;
		njWaitVSync();
	}
	/*	ADXT nh̏	*/
	ADXT_Destroy(adxt);
}

/*	ADXCuŃG[Ƃ̃R[obN֐	*/
void userAdxErrFunc(void *obj, char *msg)
{
	/*	G[Ƃ̊֐Ăяo܂B						*/
	/*	msg ɃG[bZ[Wn܂B								*/
	/*	msǵAR5WX^Ɋi[Ă̂ŁAR5WX^̃AhX		*/
	/*	_v邱ƂɂăG[bZ[Wm邱Ƃł܂B		*/
	/*	̊֐́AV-Sync荞݂Ăяo邱Ƃ܂̂ŁA		*/
	/*	Ninjå֐͎gpȂłB									*/
	/*	܂AAvP[V[XƂ́Aɖ߂悤	*/		/*	֐ɂĂB												*/

	for (;;);		/*	[Xɂ͖								*/

}

void main(void)
{
	void *snddrv;

	/* \̏ */
    njSetBorderColor( 0x00000000 ) ;
	sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI,
										NJD_FRAMEBUFFER_MODE_RGB565, 1 );
	njInitVertexBuffer( -30000, 0, 30000, 0, 0);
    njInitPrint(NULL, 0, 0);
	njSetBackColor(0x00000000,0x00000000,0x000000FF);
	/* GDt@CVXeG[R[obN֐̓o^	*/
	gdFsEntryErrFuncAll((void *)usr_gd_err_func, NULL);

	/* TEhCȕ */
	snddrv = load_file("manatee.drv", NULL);
	sound_init(snddrv);
	/* DMA ][h	*/
	sdMemBlkSetTransferMode(SDE_MEMBLK_TRANSFER_MODE_DMA);
	njSetVSyncFunction((void (*)(void))usr_vsync_func);

	/*	Cu	*/
	ADXT_Init();
	/*	G[R[obN֐̓o^	*/
	ADXT_EntryErrFunc(userAdxErrFunc, NULL);

	for (;;)
		adxsmp();	/*	ADXf[^̍Đ	*/

	/*	CuI	*/
	ADXT_Finish();
	/*	ECȕI				*/
	sbExitSystem();
	/*	VvvCփWv			*/
	syBtExit();
}
