/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XN[gk
  ҏW F 98-04-27 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
#define VERTEX_MAX  1000     /* _̍ő吔 */

/* eNX`f[^ */
#define TEXTURE_NUM  1  /* eNX`f[^̐ */

static NJS_VERTEX_BUF *vbuf;

/* LbVɓǂݍ܂eNX`` */
static NJS_TEXNAME g_TexName[] = {"tex.pvr", NJD_TEXATTR_GLOBALINDEX, 0};
static NJS_TEXLIST g_TexList = {g_TexName, TEXTURE_NUM};
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM];

/* XN[pf[^ */
#define MAP_CELL_WIDTH  5
#define MAP_CELL_HEIGHT 4

static Uint32 g_Map[MAP_CELL_HEIGHT][MAP_CELL_WIDTH] = {
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
};

static NJS_SCROLL g_Scroll;

/* |[YtO */
Bool g_bPause = FALSE;

/* |[Y֐ */
void PausePhase(void);
/* ANeBu֐ */
void ActivePhase(void);

/***************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

***************************************************************************/

void njUserInit (void)
{
    /* ʃ[ȟ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* ^Rg[{bNXւ̑Ή */
/*	pdSetMode(PDD_MODE_TYPE_A);*/
	
    vbuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * VERTEX_MAX);
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)vbuf,0x800*10);
    /* _̍ő吔obt@AP[g */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* eNX`̃[hƃZbgAbv */
    njInitTexture(g_Texture, TEXTURE_NUM);  /* eNX`f[^̈m */
    njLoadTexture(&g_TexList);  /* eNX`XgɂeNX`f[^*/
                                /* eNX`Ƀ[h */
    /* XN[̃ZbgAbv */
    g_Scroll.celps = 128;           /* Z̃sNZTCY */
    g_Scroll.mapw = MAP_CELL_WIDTH; /* }bv̉̃Ž */
    g_Scroll.maph = MAP_CELL_HEIGHT;/* }bv̏c̃Ž */
    g_Scroll.sw = 0;                /* XN[ʂ̕`扡̑傫 */
    g_Scroll.sh = 0;                /* XN[ʂ̕`c̑傫 */
    g_Scroll.list = &g_TexList;     /* eNX`Xgw */
    g_Scroll.map = (Uint32 *)g_Map; /* }bvzw */
    g_Scroll.px = 0.0F;             /* XN[ʂ̈ړW */
    g_Scroll.py = 0.0F;
    g_Scroll.bx = 0.0F;             /* }bv̏n߂̍W */
    g_Scroll.by = 0.0F;                 
    g_Scroll.pr = -100.0F;          /* XN[̃vCIeBiD揇ʁj*/
    g_Scroll.sflag = OFF;           /* gk邩Ȃ̃tO */
    g_Scroll.mflag = OFF;           /* ]邩Ȃ̃tO */
    g_Scroll.colmode = NJD_COLOR_MODE_PACKED_TEXTURE;/* J[[h̎w */
    g_Scroll.sclc.argb.a = 255;     /* XN[ŜɂJ[ */
    g_Scroll.sclc.argb.r = 255;
    g_Scroll.sclc.argb.g = 255;
    g_Scroll.sclc.argb.b = 255;

    /* wiݒ */
    /*  E  ̃J[w */
    njSetBackColor(0xffc00000, 0xff00c000, 0xff0000c0); 
    /* eLXg̃J[w */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/***************************************************************************

    njUserMain --- NinjaVXeC֐

***************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* WCXeBbN|[gP̃ytF擾 */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* {^ꂽǂ`FbN */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {
	    /* XN[̕` */
   		njDrawScroll(&g_Scroll);
	} else {
	    njPrintC(NJM_LOCATION(19, 15), "PAUSE");
	}	
	
    /* fobO̕\ */
    njPrintC(NJM_LOCATION(10, 6), "Ninja Sample SCROLL");
    
    return NJD_USER_CONTINUE;
}


/***************************************************************************

    njUserExit --- NinjaVXeI֐

***************************************************************************/

void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    sbExitSystem(); /* VXȅIs܂ */
}
