/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F XvCgilp`|Sjɔ
  ҏW F 98-04-28 Jn
              98-06-19 SET5Ή
              98-09-16 eNX`obt@mۂ̃TCYύX
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* O[oZNV */
#define VERTEX_MAX  1000     /* _̍ő吔 */

/* eNX`f[^ */
#define TEXTURE_NUM  1  /* eNX`f[^̐ */

static NJS_VERTEX_BUF  *g_VBuf;

/* LbVɓǂݍ܂eNX`` */
static NJS_TEXNAME g_TexName[] = {"tex.pvr", NJD_TEXATTR_GLOBALINDEX, 0};
static NJS_TEXLIST g_TexList = {g_TexName, TEXTURE_NUM};
static NJS_TEXMEMLIST g_Texture[TEXTURE_NUM];

/* XN[pf[^ */
#define MAP_CELL_WIDTH  5
#define MAP_CELL_HEIGHT 4

static Uint32 g_Map[MAP_CELL_HEIGHT][MAP_CELL_WIDTH] = {
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                    NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                    NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                    NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)},
    {NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0), 
                                    NJM_MAP(0, 0, 0), NJM_MAP(0, 0, 0)}, 
};

static NJS_SCROLL  g_Scroll;                   /* XN[\ */
static Angle       g_Ang = NJM_DEG_ANG(0.0);   /* XN[]px */


/***************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- NinjaVXe֐

***************************************************************************/

void njUserInit (void)
{
    /* ʃ[ȟ */
    sbInitSystem(NJD_RESOLUTION_320x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /* ̊蓖 */
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)g_VBuf,0x800*10);

    /* _̍ő吔obt@AP[g */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* eNX`̃[hƃZbgAbv */
    njInitTexture(g_Texture, TEXTURE_NUM); /* eNX`f[^̈m */
    njLoadTexture(&g_TexList);  /* eNX`XgɂeNX`f[^ */
                                /* eNX`Ƀ[h */
    /* XN[̃ZbgAbv */
    g_Scroll.celps = 128;           /* Z̃sNZTCY */
    g_Scroll.mapw = MAP_CELL_WIDTH; /* }bv̉̃Ž */
    g_Scroll.maph = MAP_CELL_HEIGHT;/* }bv̏c̃Ž */
    g_Scroll.sw = 0;                /* XN[ʂ̕`扡̑傫 */
    g_Scroll.sh = 0;                /* XN[ʂ̕`c̑傫 */
    g_Scroll.list = &g_TexList;     /* eNX`Xgw */
    g_Scroll.map = (Uint32 *)g_Map; /* }bvzw */
    g_Scroll.px = 0;                /* XN[ʂ̈ړW */
    g_Scroll.py = 0;
    g_Scroll.bx = 0;                /* }bv̏n߂̍W */
    g_Scroll.by = 0;                    
    g_Scroll.pr = -100.0f;          /* XN[̃vCIeBiD揇)*/
    g_Scroll.sflag = OFF;           /* gk邩Ȃ̃tO */
    g_Scroll.mflag = ON;            /* ]邩Ȃ̃tO */
    g_Scroll.cx = 320.0F;           /* ]SW */
    g_Scroll.cy = 240.0F;
    g_Scroll.m[0] = njCos(NJM_DEG_ANG(0.0F));/* ]}gNX̎w */
    g_Scroll.m[1] =-njSin(NJM_DEG_ANG(0.0F));
    g_Scroll.m[2] = njSin(NJM_DEG_ANG(0.0F));
    g_Scroll.m[3] = njCos(NJM_DEG_ANG(0.0F));
    g_Scroll.colmode = NJD_COLOR_MODE_PACKED_TEXTURE; /* J[[h̎w */
    g_Scroll.sclc.argb.a = 0xff;     /* XN[ŜɂJ[ */
    g_Scroll.sclc.argb.r = 0xff;
    g_Scroll.sclc.argb.g = 0xff;
    g_Scroll.sclc.argb.b = 0xff;

    /* wiݒ */
    njSetBackColor(ARGB(255, 255, 0, 0), 
                        ARGB(255, 0, 255, 0), ARGB(255, 0, 0, 255));

}


/***************************************************************************

    njUserMain --- NinjaVXeC֐

***************************************************************************/

Sint32 njUserMain(void)
{
    g_Ang += NJM_DEG_ANG(0.25F);     /* ]pxXV */
    g_Scroll.m[0] = njCos(g_Ang);   /* ]}gNXω */
    g_Scroll.m[1] =-njSin(g_Ang);
    g_Scroll.m[2] = njSin(g_Ang);
    g_Scroll.m[3] = njCos(g_Ang);
    
    /* XN[̕` */
    njDrawScroll(&g_Scroll);

    /* fobO̕\ */
    njPrintC(NJM_LOCATION(5, 5), "Ninja Sample");
    njPrintC(NJM_LOCATION(5, 7), "Scroll Rotation");
    
    return NJD_USER_CONTINUE;
}


/***************************************************************************

    njUserExit --- NinjaVXeI֐

***************************************************************************/

void njUserExit(void)
{
	njExitPrint();
    njExitTexture();
    syFree(g_VBuf);
    sbExitSystem(); /* VXȅIs܂ */
}
