/*
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *
 *       Shinobi Library
 *
 *  Module  : Library Header File
 *  File    : shinobi.h
 *  Create  : 1998-03-25
 *  Modify  : 1998-12-01
 *  Version : 1.32
 *  Note    :
 */

#ifndef _SHINOBI_H_
#define _SHINOBI_H_

#include <machine.h>      /* SHCgݍ݊֐                          */
#include <ninja.h>        /* NinjaCu                          */
#include <ninjapad.h>     /* NinjapRg[Cu            */
#include <sg_pad.h>       /* Rg[Cu                   */
#include <sg_gd.h>        /* GDCu                             */
#include <sg_sytmr.h>     /* ^C}Cu                         */
#include <sg_syrtc.h>     /* A^CNbNCu           */
#include <sg_sd.h>        /* TEhCu                       */
#include <sg_maloc.h>     /* ǗVXeCu             */
#include <sg_sycbl.h>     /* P[uʃCu                   */
#include <sg_sycfg.h>     /* RtBM[VCu         */
#include <sg_sybt.h>      /* BOOT ROMT[rX[`Cu       */
#include <sg_btfnt.h>     /* BOOT ROMtHgCu               */
#include <sg_lcd.h>       /* tCueCu             */
#include <sg_pdkbd.h>     /* L[{[hCuCu             */
#include <sg_pdvib.h>     /* UpbNCuCu             */
#include <sg_bup.h>       /* obNAbvCuu             */
#include <sg_cache.h>     /* LbVCuCu             */
#include <sg_sysrt.h>     /* X^[gAbv(C++)Cu            */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern void sbInitSystem(Int mode, Int frame, Int count);
extern void sbExitSystem(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* _SHINOBI_H_ */

/******************************* end of file *******************************/
